#pragma comment(linker, "/ENTRY:WMain")
#pragma comment(linker, "/NODEFAULTLIB")
#pragma comment(linker, "/SUBSYSTEM:CONSOLE")
#pragma comment(linker, "/merge:.rdata=.text")
#pragma comment(linker, "/merge:.data=.text")
#pragma comment(linker, "/SECTION:.text,EWR")

#include <windows.h>
#undef RtlMoveMemory
extern VOID __stdcall RtlMoveMemory(IN VOID UNALIGNED *Destination, IN CONST VOID UNALIGNED *Source, IN SIZE_T Length); // export

BYTE LDE(PVOID Address)
{
	CONTEXT context;
	DEBUG_EVENT DBEvent;
	STARTUPINFO startinfo;
	PROCESS_INFORMATION pi;
	HANDLE hThread, hProcess;
	BYTE CodeSize = 0;
	DWORD Region;
	BOOL Started = FALSE;
	DWORD dwWritten;

	GetStartupInfo(&startinfo);
	CreateProcessA("Empty.exe", NULL, NULL, NULL, FALSE, DEBUG_PROCESS + DEBUG_ONLY_THIS_PROCESS, NULL, NULL, &startinfo, &pi);
	while (1)
	{
		WaitForDebugEvent(&DBEvent, INFINITE);
		if (DBEvent.dwDebugEventCode == CREATE_PROCESS_DEBUG_EVENT)
		{
			hThread = DBEvent.u.CreateProcessInfo.hThread;
			hProcess = DBEvent.u.CreateProcessInfo.hProcess;
		}
		if (DBEvent.dwDebugEventCode == EXCEPTION_DEBUG_EVENT)
		{
			context.ContextFlags = CONTEXT_CONTROL;
			GetThreadContext(hThread, &context);
			if ((DBEvent.u.Exception.ExceptionRecord.ExceptionCode == EXCEPTION_ACCESS_VIOLATION) &&
				(DBEvent.u.Exception.ExceptionRecord.ExceptionInformation[0] == 8)) // #AV (DEP)
			{
				Region -= 1;
				CodeSize += 1;
				WriteProcessMemory(hProcess, Region, Address, CodeSize, &dwWritten);
				context.EFlags |= 0x00000100; //   ( TF)
				context.Eip = Region;
				SetThreadContext(hThread, &context);
			}
			else //   
			{
				//        EXEPTION_BREAKPOINT
				if ((DBEvent.u.Exception.ExceptionRecord.ExceptionCode == EXCEPTION_BREAKPOINT) && (!Started))
				{
					// 2      RWE,   
					Region = 0; //     
					//  2  ; 0x2000 = PAGE_SIZE*2
					Region = (DWORD)VirtualAllocEx(hProcess, (LPVOID)Region, 0x2000, MEM_RESERVE, PAGE_NOACCESS);
					// 0x1000 = PAGE_SIZE
					//        RWE
					Region = (DWORD)VirtualAllocEx(hProcess, (LPVOID)Region, 0x1000, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
					Region += 0x1000; // to #AV
					context.EFlags |= 0x00000100; //   ( TF)
					context.Eip = Region; //  eip   Region
					SetThreadContext(hThread, &context);
					Started = TRUE;
				}
				else
				{
					TerminateProcess(hProcess, 0);
				}
			}
		}
		if (DBEvent.dwDebugEventCode == EXIT_PROCESS_DEBUG_EVENT) break;
		ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_CONTINUE);
	}
	return CodeSize;
}

void WMain(void)
{
	BYTE StartCodeBuf[] = { 0xCC, 0xBC, 0x00, 0x00, 0x00, 0x00, 0x8E, 0xD0, 0xA3, 0x00, 0x10, 0x23, 0x00 };
	HANDLE stdOutHandle;
	HANDLE stdInHandle;
	DWORD dwWritten;
	char Buffer[1];
	char HexBuffer[100];

	SetConsoleTitleA("Process LDE");
	stdOutHandle = GetStdHandle(STD_OUTPUT_HANDLE);
	stdInHandle = GetStdHandle(STD_INPUT_HANDLE);
	wsprintfA(HexBuffer, "Instruction Length - 0x%.2X\r\n", LDE(StartCodeBuf));
	WriteConsoleA(stdOutHandle, HexBuffer, lstrlenA(HexBuffer), &dwWritten, 0);
	ReadConsoleA(stdInHandle,Buffer,0,&dwWritten,0);
}